package meta_programming;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.*;

import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

public class Sample18 {
	@Target(TYPE)
	@Retention(RUNTIME)
	@Inherited
	public static @interface Foo {
		String[] value() default { "a", "b" };

		boolean foo() default true;

		Bar bar();
	}

	public static @interface Bar {
		Class<?> value();
	}

	@Foo(bar = @Bar(Date.class))
	public static class Baz {
	}

	public static class Qux extends Baz {
	}

	@Foo(bar = @Bar(List.class), value = "", foo = false)
	public static class Garply extends Baz {
	}

	public static void main(String[] args) {
		Foo foo = Qux.class.getAnnotation(Foo.class);

		System.out.println(Arrays.asList(foo.value()));
		System.out.println(foo.foo());
		System.out.println(foo.bar().value());
		System.out.println();

		foo = Garply.class.getAnnotation(Foo.class);

		System.out.println(Arrays.asList(foo.value()));
		System.out.println(foo.foo());
		System.out.println(foo.bar().value());
	}
}
