package meta_programming;

import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.io.Serializable;

public class Sample22 {
	public static void main(String[] args) throws Exception {
		BeanInfo beanInfo = Introspector.getBeanInfo(Foo.class);

		PropertyDescriptor[] propertyDescriptors = beanInfo
				.getPropertyDescriptors();
		for (PropertyDescriptor pd : propertyDescriptors) {
			System.out.println("PropertyName : " + pd.getName());
			System.out.println("GetterMethod : "
					+ pd.getReadMethod());
			System.out.println("SetterMethod : "
					+ pd.getWriteMethod());
			System.out.println();
		}
	}

	public static class Foo implements Serializable {
		private static final long serialVersionUID = -7410405528992952442L;

		private int foo;

		private boolean bar;

		private Object baz;

		public boolean isBar() {
			return bar;
		}

		public void setBar(boolean bar) {
			this.bar = bar;
		}

		public Object getBaz() {
			return baz;
		}

		public void setBaz(String baz) {
			this.baz = baz;
		}

		public int getFoo() {
			return foo;
		}

		public void setFoo(int foo) {
			this.foo = foo;
		}
	}
}
