package meta_programming;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Sample24 {
	public static void main(String[] args) throws Exception {
		Class<?>[] interfaces = BarImpl.class.getInterfaces();
		System.out.println(Arrays.asList(interfaces));

		List<Class<?>> allInterfaces = getAllInterfaces(BarImpl.class);
		System.out.println(allInterfaces);
	}

	private static List<Class<?>> getAllInterfaces(Class<?> clazz) {
		List<Class<?>> ret = new ArrayList<Class<?>>();
		addInterfaces(clazz, ret);
		return ret;
	}

	private static void addInterfaces(Class<?> targetClass,
			List<Class<?>> interfaces) {
		if (targetClass == null) {
			return;
		}
		interfaces.addAll(Arrays.asList(targetClass
				.getInterfaces()));
		addInterfaces(targetClass.getSuperclass(), interfaces);
	}

	public static interface Foo {
	}

	public static class FooImpl implements Foo {
	}

	public static interface Bar {
	}

	public static class BarImpl extends FooImpl implements Bar {
	}
}
